// DiffTests_console.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Windows.h"


///////////////////////////


//#define ID_DIST_WATCHDOG_TIMER	123123
#define ID_DIST_TEST_TIMER			123124
#define WATCHDOG_EVENT					"Watchdog_event"
#define TEST_TIME								1000
#define EVENT_TIME							3000

HANDLE m_hEvent = 0;
HANDLE m_hThreadWD = 0;

bool startTimer(UINT_PTR nIdTimer, UINT nElapse);
bool killTimer(UINT_PTR nIdTimer);
VOID CALLBACK MyTimerProc( HWND hwnd, UINT message, UINT idTimer, DWORD dwTime);
DWORD WINAPI WatchProcess( LPVOID lpParam );
void restartMainProc();
void startWatchdog();
void startTest();
void testWatchdog();

//////////////////////////////

int _tmain(int argc, _TCHAR* argv[])
{
	killTimer(ID_DIST_TEST_TIMER);

	// watch dog
	testWatchdog();
	
	return 0;
}


//////////////////////////////////
/////////// timer ///////////
//////////////////////////////////

VOID CALLBACK MyTimerProc( 
    HWND hwnd,        // handle to window for timer messages 
    UINT message,     // WM_TIMER message 
    UINT idTimer,     // timer identifier 
    DWORD dwTime)     // current system time 
{ 
	// set event (for controlled process) / state = free
	HANDLE hEvent;
	bool bOk = ::SetEvent(m_hEvent);
	if (bOk == false)
	{
		// ERROR
		return;
	}

	killTimer(ID_DIST_TEST_TIMER);
	startTimer(ID_DIST_TEST_TIMER, TEST_TIME);
}

///////// kill timer ////////////
bool killTimer(UINT_PTR nIdTimer)
{
	return  ::KillTimer( NULL, nIdTimer );
}



/////////// start timer /////////////////////
bool startTimer(UINT_PTR nIdTimer, UINT nElapse)
{	
	// set timer for 10 sec
	UINT uResult = ::SetTimer( NULL, nIdTimer, nElapse, (TIMERPROC)MyTimerProc );
	if (uResult == 0)
	{
		// ERROR
		return false;
	}

	return true;
}

////////////////////////////////////////////////////
///////////// watchdog//////////////////////
///////////////////////////////////////////////////


/////////////// thread function ///////////////
DWORD WINAPI WatchProcess( LPVOID lpParam )
{
	int i = 0;

	bool bProcessOk = true;
	while(bProcessOk)
	{
		// check event (if free - chenge the state to busy)
		DWORD dwWaitResult = ::WaitForSingleObject(m_hEvent, EVENT_TIME);

		switch (dwWaitResult) 
		{
				// The state of the specified object is signaled => The thread got ownership of the event
				case WAIT_OBJECT_0: 
						// process exists - OK
						i = 5;
						break; 

				// The time-out interval elapsed, and the object's state is nonsignaled
				case WAIT_TIMEOUT:
					bProcessOk = false;
					restartMainProc(); // test visit => killTest
					break;

				// The thread got ownership of an abandoned event
				case WAIT_ABANDONED: 
						restartMainProc(); // test visit => killTest
						break; 
		}
	}

	return 1;
}



////////////// start thread////////////////////
void startWatchdog()
{
	DWORD ThreadID = 0;
	m_hThreadWD = ::CreateThread(  NULL,       // default security attributes
																 0,          // default stack size
																 (LPTHREAD_START_ROUTINE) WatchProcess, 
																 NULL,       // no thread function arguments
																 0,          // default creation flags
																 &ThreadID); // receive thread identifier

	if ( m_hThreadWD == 0 )
	{
		// ERROR
		return;
	}
}



//////////////////////////////////////////
/////////////// start test ////////////
//////////////////////////////////////////

/////////// restart test ////////////////
void restartMainProc()
{
	// must be killProcess() ...
	int i = 0;
	i++;
}

/////////////// start test ////////////////////
void startTest()
{
	// set application-timer
	bool bOk = startTimer(ID_DIST_TEST_TIMER, TEST_TIME);
	if (bOk == false)
	{
		// ERROR
		return;
	}

	// our test... 
	for (int i = 0; i < 1000; i++)
	{
		int j = i + 10;
		Sleep(800);
	}

}

///////////// main function //////////////////
void testWatchdog()
{
	// create event (state = free)
	m_hEvent = ::CreateEvent( NULL, false, true, _T(WATCHDOG_EVENT) );
	if ( m_hEvent == 0 )
	{
		// ERROR
		return;
	}

	// start watchdog
	startWatchdog();

	// start test
	startTest();
}

